

function [M] = calc_moment(N,d,level)

% Get the daubechies coefficients
h = sqrt(2).*daub_coefficients(N);

nO = (2.*(N-1))-1;
midO = ceil(nO./2);
momw = zeros(d+1,1);
momw(1) = 1;
M = zeros(d+1,nO);

sqtwo_p = sqrt(2.^level);
temp = sqrt(0.5);

for l=1:nO
    M(1,l) = 1./sqtwo_p;
end


% This uses Nielsons notation and may be a little different? Giving us
% better condition numbers?
for p=1:d  
    for n=0:p-1       
        temp = 0; 
        for k=0:N-1              
            temp = temp + h(k+1).*(k.^(p-n));
        end                        
        momw(p+1) = momw(p+1) + nchoosek(p,n).*momw(n+1).*temp;            
    end
    momw(p+1) = (sqrt(2)./(2.*((2^p)-1))).*momw(p+1);
end


if(d>0)

    % Put the value of M0 in M middle
    M(:,midO) = momw(2:length(momw));

    % Now that We have the M_0 terms we can find the other moments so that
    % we end up with M^d_i
    for k=1:d
        for i=1:N-2    
            for j=0:k       
                M(k+1,midO-i) = M(k,midO-i) + nchoosek(k,j).*((-i).^(k-j)).*momw(j+1);
                M(k+1,midO+i) = M(k,midO+i) + nchoosek(k,j).*(i.^(k-j)).*momw(j+1);
            end

    %              M(k,N_mid-i) = M(k,N_mid-i)./(2^(level.*(k+.5)));
    %              M(k,N_mid+i) = M(k,N_mid+i)./(2^(level.*(k+.5)));

        end

        M(k+1,:) = M(k,:)./(2^(level.*(k+.5)));

        %b((2.*N)-3+k) = factorial(k);

    end
end
