% This function will be used to calculate a set
% of snapshots and write them to a file
%

%function [S] = generate_snapshots(N,level)
    clear
	clc
	close all
    
    N = 12;
    level = 6;
    T = .1;
    dt = (1/(2^level))^2;
    
    % Number of solutions to grab from the solution matrix
    nsols = 5;
    
    % Create the vectors of values
    eta = 1;
	beta = 0:2;
	gamma = 0;
	alpha =  0:2;
    
	% Get the size of the domain and such
	[xl,xr,ul,ur] = geometry();

	% How many points per case we have
	x = xl:(1/(2.^(level))):xr;

	% The snapshot matrix
	S = zeros(length(x)-2,length(eta).*length(beta).*length(alpha));
    
    % Position in the snapshot matrix
    iS = 1;
    
	% The levels we would like to test
	%for i = 1:length(eta);
        for j = 1:length(beta)
            for k = 1:length(alpha)
                
                % A random vector to grab a number of solution vectors from the
                % simulation
                r = round((floor(T./((1/(2^level))^2))-1)*rand(nsols,1) + 1);
            
                % Run the test case we would like to solve
                [~,~,~,~,U] = wavelet_ode(N,level,dt,T,eta,beta(j),gamma,alpha(k),0);

                % Put the solution vector in our snapshot matrix
%                 U(:,r)
%                 S(:,iS:iS+4) = U(:,r)
                
                % Non time dependant case just grab the solution
                S(:,iS:iS+nsols-1) = U(:,r);
                
                % Increment iS
                iS = iS + nsols;
                
            end
        end		
	%end
	
    
	% Write out the snapshot matrix to a file so that we can
	% use it to generate our basis
	
	% Create the filename
	filename = ['Snapshots_D',num2str(N),'_L',num2str(level),'.txt']
	
	% Write the snapshots to file
	dlmwrite(filename,S);
	
%end
