% This function is easy, it just performs the singular value decomposition
% on our snapshot matrix and returns the basis we want along with
% the singular value in vector form

function [BASIS, s] = generate_basis(S)

	clc
	close all
	
	% Check if S is a filename
	if(exist(S) == 2)
		% Then read it in and set the matrix to x
		S = dlmread(S);
	end
		
	% Perform the SVD on the matrix
	[BASIS,s,V] = svd(3.*S);
	
	% put the singular values in a vector
	s = spdiags(s);
    
    % Write out the Basis 
    dlmwrite('BASIS.txt',BASIS);
    
end