% This makes the differentiation matrix

function [D] = make_Diff_matrix(N,nD,Omega)

% Get the size of omega
nO = length(Omega);
midO = ceil(nO./2);

% Initiate D
D =  zeros(nD,nD);

% The Left Boundary
iD = [1, midO];
iDe = [nD-midO+2,nD];
iO = [midO,nO];
iOe = [1,midO-1];
for i=1:N-2 
    % Put in the connection coefficients
    D(i,iD(1):iD(2)) = Omega(iO(1):iO(2));
    D(i,iDe(1):iDe(2)) = Omega(iOe(1):iOe(2));

    % Shift the Omega and the position in the A
    % matrix
    iD(2) = iD(2) + 1;
    iDe(1)= iDe(1) + 1;
    iO(1) = iO(1) - 1;
    iOe(2) = iOe(2) - 1;

end

% For the functions that are actually in our interval
iD = [1,nO];
for i=N-1:(nD-N+2)

    % Put in the connection coeffs
    D(i,iD(1):iD(2)) = Omega;

     % Increment the position in the D matrix
     iD = iD + 1;

end

% The Right boundary
iD = [nD-nO+2,nD];
iDb = [1,1];
iO = [1, nO-1];
iOb = [nO,nO];
for i=(nD-N+3):nD

    % Put in the connection coefficients
    iD(1):iD(2)
    iO(1):iO(2)
    D(i,iD(1):iD(2)) = Omega(iO(1):iO(2));
    D(i,iDb(1):iDb(2)) = Omega(iOb(1):iOb(2));
    
    % Shift the Omega and the position in the A
    % matrix
    iD = [iD(1)+1,iD(2)];
    iDb(2) = iDb(2) + 1;
    iO = [iO(1), iO(2)-1];
    iOb(1) = iOb(1) - 1;

end