
clear
clc
close all;


i = 1;



fprintf('\\begin{center}\n');
fprintf('\\begin{tabular}{| c | c | c |}\n');
fprintf('Scaling function &  Euclidean Error & Condition Number \\\\\n');
fprintf('\\hline\n');


for N=6:2:20
    
    [x,uh(:,i),cond,t,~] = wavelet_ode(N,3,(1/(2^3))^2,.1,1,1,0,1,0);
    uex = u_exact(x,t);
    
    Err =  norm(uh(:,i) - uex)./norm(uex);
    fprintf('D%i & %7.5e & %7.5e \\\\\n',N,Err,cond);
    
    i = i+1;
end

% figure(1)
% hold on
% xlabel('x','FontSize',16);
% ylabel('u(x,t)','FontSize',16);
% title(strcat('Wavelet Galerkin solutions $\Delta x =  \frac{1}{2^3}$'),'FontSize',16,'Interpreter','latex');
% plot(x,uh(:,1),'*-','LineWidth',1.5);
% plot(x,uh(:,2),'+-','LineWidth',1.5);
% plot(x,uh(:,3),'o-','LineWidth',1.5);
% plot(x,uh(:,4),'^-','LineWidth',1.5);
% plot(x,,'r','LineWidth',1.5)
% legend('D6','D8','D10','D12','u_{exact}');
% %legend('D14','D16','D18','D20','u_{exact}');
% set(gca,'FontSize',16);
% hold off;